#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using ll = long long;
using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()
#define int long long

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct segTree {
    int n;
    vector<int> t;

    void build(int v, int l, int r, vector<int>& a) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }

        int m = (l + r) / 2;

        build(v * 2, l, m, a);
        build(v * 2 + 1, m, r, a);

        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    segTree(vector<int>& a) {
        n = a.size();
        t.resize(4 * n);
        build(1, 0, n, a);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql) {
            return INT_MIN;
        }

        if (ql <= l && r <= qr) {
            return t[v];
        }

        int m = (l + r) / 2;

        return max(get(v * 2, l, m, ql, qr), get(v * 2 + 1, m, r, ql, qr));
    }

    int get(int ql, int qr) {
        return get(1, 0, n, ql, qr);
    }

    void upd(int v, int l, int r, int idx, int val) {
        if (r - l == 1) {
            t[v] = val;
            return;
        }

        int m = (l + r) / 2;

        if (idx < m) {
            upd(v * 2, l, m, idx, val);
        } else {
            upd(v * 2 + 1, m, r, idx, val);
        }

        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }

    void upd(int ql, int qr) {
        upd(1, 0, n, ql, qr);
    }
};

void solve() {
    int n;

    cin >> n;

    vector<int> a(n);

    for (int& i : a) cin >> i;

    ordered_set<pair<int, int>> st;

    for (int i = 0; i < n; i++) {
        st.insert({i, i + 1});
    }

    segTree st1(a);

    for (int i = 0; i < n - 1; i++) {
        int k;

        cin >> k;

        k--;

        pair<int, int> p1 = *st.find_by_order(k);
        pair<int, int> p2 = *st.find_by_order(k + 1);

        st.erase(p1);
        st.erase(p2);

        int ans = 0;

        for (int i = p1.first; i < p2.second; i++) {
            ans += min(st1.get(p1.first, i + 1), st1.get(i, p2.second)) - a[i];
        }

        st.insert({p1.first, p2.second});

        cout << ans << "\n";
    }
}

signed main() {
    int t = 1;

    // cin >> t;

    while (t--) {
        solve();
    }
}