#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define int long long

const int inf = 1e18;

using namespace std;

struct segTree {
    int n;
    vector<int> t;

    void build(int v, int l, int r, vector<int>& a) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }

        int m = (l + r) / 2;

        build(v * 2, l, m, a);
        build(v * 2 + 1, m, r, a);

        t[v] = min(t[2 * v], t[2 * v + 1]);
    }

    segTree(vector<int>& a) {
        n = a.size();
        t.resize(4 * n);
        build(1, 0, n, a);
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (l >= qr || r <= ql) {
            return inf;
        }

        if (ql <= l && r <= qr) {
            return t[v];
        }

        int m = (l + r) / 2;

        return min(get(v * 2, l, m, ql, qr), get(2 * v + 1, m, r, ql, qr));
    }

    int get(int ql, int qr) {
        return get(1, 0, n, ql, qr);
    }
};

void solve() {
    int n, k;

    cin >> n >> k;

    if (k == 1) {
        cout << "0\n";
        return;
    }

    vector<int> a(n);

    for (int& i : a) cin >> i;

    int d = 0;
    vector<int> p(n + 1);

    for (int i = 1; i <= n; i++) {
        p[i] = p[i - 1] + a[i - 1];
    }

    vector<int> pref(n);
    pref[0] = a[0];

    vector<int> suff(n);
    suff[n - 1] = a[n - 1];

    for (int i = 1; i < n; i++) {
        pref[i] = min(pref[i - 1], a[i]);
    }

    for (int i = n - 2; i >= 0; i--) {
        suff[i] = min(suff[i + 1], a[i]);
    }

    vector<int> sec(n), fir(n);

    for (int i = 0; i < n - 1; i++) {
        sec[i] = p[i + 1] - suff[i + 1];
    }

    for (int i = 1; i < n; i++) {
        fir[i] = p[i] + pref[i - 1];
    }

    segTree st(fir);
    segTree st1(p);

    if (k == 2) {
        for (int i = 0; i < n - 1; i++) {
            int p1 = p[i + 1] - p[0];
            int p2 = p[n] - p[i + 1];

            d = max(d, max(p1, p2) - min(p1, p2));
        }

        cout << d << "\n";
        return;
    }

    for (int r1 = 0; r1 < n; r1++) {
        for (int l1 = max(1ll, r1 + k - n); l1 <= r1; l1++) {
            if (l1 != 0) {
                // int sm1 = p[r1 + 1] - p[l1];
                // int sm2 = pref[l1 - 1];
                d = max(d, p[r1 + 1] - fir[l1]);
            }
        }
    }

    for (int r1 = 0; r1 < n; r1++) {
        for (int l1 = max(0ll, r1 + k - n); l1 <= r1; l1++) {
            if (r1 != n - 1) {
                // int sm1 = p[r1 + 1] - p[l1];
                // int sm2 = suff[r1 + 1];
                d = max(d, sec[r1] - p[l1]);
            }
        }
    }

    cout << d << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;

    // cin >> t;

    // for (int i = 1; i <= 100; i++) {
    //     cout << i << ' ';
    //     solve(i);
    // }

    while (t--) {
        solve();
    }
}